import 'dart:io';

import 'package:dotup_dart_logger/dotup_dart_logger.dart';
import 'package:uuid/uuid.dart';

import '../dotup_flutter_logger_sqflite_writer.dart';
import 'Bootstrapper.dart';
import 'LoggerRepository.dart';
import 'database/DatabaseRepositoryManager.dart';

class SqfLiteLogWriter implements ILogWriter {
  late final LoggerRepository repository;
  late final DatabaseRepositoryManager _rm;

  @override
  LogLevel logLevel;

  SqfLiteLogWriter(this.logLevel);

  Future<void> initialize(String database) async {
    _rm = await Bootstrapper().initialize(database);
    repository = _rm.getRepository<LoggerRepository>()!;
  }

  @override
  void write(LogEntry logEntry) {
    repository.create(LoggerMapper.toLoggerEntity(Uuid().v4(), logEntry));
  }
}
